|  | Home | Documentation | xml-rpc.h File Reference updated by Robert van Engelen |

Classes | Typedefs | Functions
xml-rpc.h File Reference
`#include "xml-rpc-iters.h"`
Include dependency graph for xml-rpc.h:

## Classes

struct | _base64
| Represents the <base64> binary data element. More...
struct | _rawdata
| Represents the <rawdata> binary data element. More...
struct | _struct
| Represents the <struct> record structure element. More...
struct | data
| Represents the <data> element. More...
struct | _array
| Represents the <array> array of values element. More...
struct | value
struct | member
| Represents the <member> element of a <struct>. More...
struct | params
| Represents the <params> of a <methodCall> request and response. More...
struct | param
| Represents a <param> of the <params> of a <methodCall>. More...
struct | methodResponse
| Represents the <methodResponse> element with response <params> and <fault>. More...
struct | methodCall
| Represents the <methodCall> element with <methodName> and request <params> for remote invocation. More...
struct | fault
| Represents the <fault> container element with a value. More...

## Typedefs

typedef char | _boolean
| Scalar <boolean> element with values 0 (false) or 1 (true).
typedef double | _double
| Scalar <double> element with double floating point.
typedef int | _i4
| Scalar <i4> element with 32 bit integer.
typedef LONG64 | _int
| Scalar <int> element with 64 bit integer.
typedef char * | _string
| Scalar <string> element.
typedef char * | _dateTime_DOTiso8601
| Scalar <dateTime.iso8601> element with ISO8601 date and time formatted string.

## Functions

struct value * | new_value (struct soap *soap)
| C/C++ function returns a pointer to a new value.
struct value * | init_value (struct soap *soap, struct value *v)
| C/C++ function to init or reset a value, returns a pointer to this value.
_boolean * | bool_of (struct value *v)
| C function returns pointer to Boolean, coerces v to Boolean if needed.
_int * | int_of (struct value *v)
| C function returns pointer to int, coerces v to int if needed.
_double * | double_of (struct value *v)
| C function returns pointer to double, coerces v to double if needed.
const char ** | string_of (struct value *v)
| C function returns pointer to string (pointer to char * to set or get), coerces v to string if needed.
const char ** | dateTime_of (struct value *v)
| C function returns pointer to string of ISO 8601, coerces v to string if needed (get time with soap_s2dateTime and set time with soap_dateTime2s).
struct _base64 * | base64_of (struct value *v)
| C function returns pointer to base64 struct, coerces v to base64 struct if needed.
struct _rawdata * | rawdata_of (struct value *v)
| C function returns pointer to string of RAW JSON.
struct value * | value_at (struct value *v, const char *s)
| C function returns pointer to member value of a struct, coerces v to struct if needed.
struct value * | value_atw (struct value *v, const wchar_t *s)
| C function returns pointer to member value of a struct, coerces v to struct if needed.
int | nth_at (const struct value *v, const char *s)
| C function returns the nth index of a name in a struct, < 0 otherwise.
int | nth_atw (const struct value *v, const wchar_t *s)
| C function returns the nth index of a name in a struct, < 0 otherwise.
int | nth_nth (const struct value *v, int n)
| C function returns the nth index if an nth index in the array exists, < 0 otherwise.
struct member * | nth_member (struct value *v, int n)
| C function returns pointer to nth member (name and value) of a struct or NULL when not exists.
struct value * | nth_value (struct value *v, int n)
| C function returns pointer to array element value at index n, coerces v to array with value at n if needed.
_boolean | is_null (const struct value *v)
| C function returns true if value is not set or assigned (JSON null).
_boolean | is_int (const struct value *v)
| C function returns true if value is a 32 or a 64 bit int.
_boolean | is_double (const struct value *v)
| C function returns true if value is a 64 bit double floating point.
_boolean | is_number (const struct value *v)
| C function returns true if value is a number (int or float).
_boolean | is_string (const struct value *v)
| C function returns true if value is a string.
_boolean | is_bool (const struct value *v)
| C function returns true if value is a Boolean "true" or "false" value.
_boolean | is_true (const struct value *v)
| C function returns true if value is Boolean "true".
_boolean | is_false (const struct value *v)
| C function returns true if value is Boolean "false".
_boolean | is_array (const struct value *v)
| C function returns true if array of values.
_boolean | is_struct (const struct value *v)
| C function returns true if structure, a.k.a. a JSON object.
_boolean | is_dateTime (const struct value *v)
| C function returns true if ISO 8601, always false for received JSON.
_boolean | is_base64 (const struct value *v)
| C function returns true if base64, always false for received JSON.
_boolean | is_rawdata (const struct value *v)
| C function returns true if RAW JSON, always false for received JSON.
void | set_struct (struct value *v)
| C function to create an empty struct.
void | set_size (struct value *v, int n)
| C function set/allocate size of array.
int | has_size (const struct value *v)
| C function returns the size of an array or struct.
int | is_empty (const struct value *v)
| C function returns true (1) if struct/array is empty or when value is not an struct/array, 0 otherwise.
struct params * | new_params (struct soap *soap)
| C function returns pointer to new parameters for XML-RPC methodCall.
struct params * | init_params (struct soap *soap, struct params *p)
| C function to clear parameters, returns a pointer to the empty parameters.
struct value * | nth_param (struct params *p, int n)
| C function returns pointer to parameter value at index n, creates new parameter if needed.
int | call_method (struct soap *soap, const char *endpoint, const char *methodName, struct params *p, struct methodResponse *r)
| C function to invoke XML-RPC methodCall on endpoint given methodCall m populates methodResponse r, returns SOAP_OK or error.

## Typedef Documentation

## ◆ _boolean

typedef char _boolean

Scalar <boolean> element with values 0 (false) or 1 (true).

## ◆ _dateTime_DOTiso8601

typedef char* _dateTime_DOTiso8601

Scalar <dateTime.iso8601> element with ISO8601 date and time formatted string.

## ◆ _double

typedef double _double

Scalar <double> element with double floating point.

## ◆ _i4

typedef int _i4

Scalar <i4> element with 32 bit integer.

## ◆ _int

typedef LONG64 _int

Scalar <int> element with 64 bit integer.

## ◆ _string

typedef char* _string

Scalar <string> element.

## Function Documentation

## ◆ base64_of()

struct _base64 * base64_of | ( | struct value * | v | ) |

extern

C function returns pointer to base64 struct, coerces v to base64 struct if needed.

## ◆ bool_of()

_boolean * bool_of | ( | struct value * | v | ) |

extern

C function returns pointer to Boolean, coerces v to Boolean if needed.

## ◆ call_method()

int call_method | ( | struct soap * | soap,
|  | const char * | endpoint,
|  | const char * | methodName,
|  | struct params * | p,
|  | struct methodResponse * | r )

extern

C function to invoke XML-RPC methodCall on endpoint given methodCall m populates methodResponse r, returns SOAP_OK or error.

## ◆ dateTime_of()

const char ** dateTime_of | ( | struct value * | v | ) |

extern

C function returns pointer to string of ISO 8601, coerces v to string if needed (get time with soap_s2dateTime and set time with soap_dateTime2s).

## ◆ double_of()

_double * double_of | ( | struct value * | v | ) |

extern

C function returns pointer to double, coerces v to double if needed.

## ◆ has_size()

int has_size | ( | const struct value * | v | ) |

extern

C function returns the size of an array or struct.

## ◆ init_params()

struct params * init_params | ( | struct soap * | soap,
|  | struct params * | p )

extern

C function to clear parameters, returns a pointer to the empty parameters.

## ◆ init_value()

struct value * init_value | ( | struct soap * | soap,
|  | struct value * | v )

extern

C/C++ function to init or reset a value, returns a pointer to this value.

## ◆ int_of()

_int * int_of | ( | struct value * | v | ) |

extern

C function returns pointer to int, coerces v to int if needed.

## ◆ is_array()

_boolean is_array | ( | const struct value * | v | ) |

extern

C function returns true if array of values.

## ◆ is_base64()

_boolean is_base64 | ( | const struct value * | v | ) |

extern

C function returns true if base64, always false for received JSON.

## ◆ is_bool()

_boolean is_bool | ( | const struct value * | v | ) |

extern

C function returns true if value is a Boolean "true" or "false" value.

## ◆ is_dateTime()

_boolean is_dateTime | ( | const struct value * | v | ) |

extern

C function returns true if ISO 8601, always false for received JSON.

## ◆ is_double()

_boolean is_double | ( | const struct value * | v | ) |

extern

C function returns true if value is a 64 bit double floating point.

## ◆ is_empty()

int is_empty | ( | const struct value * | v | ) |

extern

C function returns true (1) if struct/array is empty or when value is not an struct/array, 0 otherwise.

## ◆ is_false()

_boolean is_false | ( | const struct value * | v | ) |

extern

C function returns true if value is Boolean "false".

## ◆ is_int()

_boolean is_int | ( | const struct value * | v | ) |

extern

C function returns true if value is a 32 or a 64 bit int.

## ◆ is_null()

_boolean is_null | ( | const struct value * | v | ) |

extern

C function returns true if value is not set or assigned (JSON null).

## ◆ is_number()

_boolean is_number | ( | const struct value * | v | ) |

extern

C function returns true if value is a number (int or float).

## ◆ is_rawdata()

_boolean is_rawdata | ( | const struct value * | v | ) |

extern

C function returns true if RAW JSON, always false for received JSON.

## ◆ is_string()

_boolean is_string | ( | const struct value * | v | ) |

extern

C function returns true if value is a string.

## ◆ is_struct()

_boolean is_struct | ( | const struct value * | v | ) |

extern

C function returns true if structure, a.k.a. a JSON object.

## ◆ is_true()

_boolean is_true | ( | const struct value * | v | ) |

extern

C function returns true if value is Boolean "true".

## ◆ new_params()

struct params * new_params | ( | struct soap * | soap | ) |

extern

C function returns pointer to new parameters for XML-RPC methodCall.

## ◆ new_value()

struct value * new_value | ( | struct soap * | soap | ) |

extern

C/C++ function returns a pointer to a new value.

## ◆ nth_at()

int nth_at | ( | const struct value * | v,
|  | const char * | s )

extern

C function returns the nth index of a name in a struct, < 0 otherwise.

## ◆ nth_atw()

int nth_atw | ( | const struct value * | v,
|  | const wchar_t * | s )

extern

C function returns the nth index of a name in a struct, < 0 otherwise.

## ◆ nth_member()

struct member * nth_member | ( | struct value * | v,
|  | int | n )

extern

C function returns pointer to nth member (name and value) of a struct or NULL when not exists.

## ◆ nth_nth()

int nth_nth | ( | const struct value * | v,
|  | int | n )

extern

C function returns the nth index if an nth index in the array exists, < 0 otherwise.

## ◆ nth_param()

struct value * nth_param | ( | struct params * | p,
|  | int | n )

extern

C function returns pointer to parameter value at index n, creates new parameter if needed.

## ◆ nth_value()

struct value * nth_value | ( | struct value * | v,
|  | int | n )

extern

C function returns pointer to array element value at index n, coerces v to array with value at n if needed.

## ◆ rawdata_of()

struct _rawdata * rawdata_of | ( | struct value * | v | ) |

extern

C function returns pointer to string of RAW JSON.

## ◆ set_size()

void set_size | ( | struct value * | v,
|  | int | n )

extern

C function set/allocate size of array.

## ◆ set_struct()

void set_struct | ( | struct value * | v | ) |

extern

C function to create an empty struct.

## ◆ string_of()

const char ** string_of | ( | struct value * | v | ) |

extern

C function returns pointer to string (pointer to char * to set or get), coerces v to string if needed.

## ◆ value_at()

struct value * value_at | ( | struct value * | v,
|  | const char * | s )

extern

C function returns pointer to member value of a struct, coerces v to struct if needed.

## ◆ value_atw()

struct value * value_atw | ( | struct value * | v,
|  | const wchar_t * | s )

extern

C function returns pointer to member value of a struct, coerces v to struct if needed.